Package twisted :: Package web :: Module widgets :: Class WidgetPage

[frames | no frames]

## Class WidgetPage

      Widget --+
               |
    Presentation --+
                   |
        Resource --+
                   |
                Page --+
                       |
                      WidgetPage

I am a Page that takes a Widget in its constructor, and displays that Widget wrapped up in a simple HTML template.

Method Summary
| `__init__(self, widget)`
| ``prePresent`(self, request)` Perform any tasks which must be done before presenting the page.
| ``render`(self, request)` Render a given resource.
Inherited from Resource
| ``delEntity`(self, name)`
| ``getChild`(self, path, request)` Retrieve a 'child' resource from me.
| ``getChildForRequest`(self, request)`
| ``getChildWithDefault`(self, path, request)` Retrieve a static or dynamically generated child resource from me.
| ``getDynamicEntity`(self, name, request)`
| ``getStaticEntity`(self, name)`
| ``listDynamicEntities`(self, request)`
| ``listDynamicNames`(self)`
| ``listEntities`(self)`
| ``listNames`(self)`
| ``listStaticEntities`(self)`
| ``listStaticNames`(self)`
| ``putChild`(self, path, child)` Register a static child.
| ``reallyPutEntity`(self, name, entity)`
| ``render_HEAD`(self, request)` Default handling of HEAD method.
Inherited from Presentation
| ``addClassVars`(self, namespace, Class)`
| ``addVariables`(self, namespace, request)`
| ``display`(self, request)` Implement me to represent your widget.
| ``formatTraceback`(self, tb)`
| ``streamCall`(self, call, *args, **kw)` Utility: Call a method like StreamWidget's 'stream'.
Inherited from Widget
| ``getTitle`(self, request)`

Class Variable Summary
`str` | `stylesheet` = `'\n a\n {\n font-family: Lucid...`
`str` | `template` = `'<html>\n <head>\n <title>%%%%self.titl...`
`str` | `title` = `'No Title'`
`str` | `widget` = `'No Widget'`
Inherited from Resource
`tuple` | `__implements__` = `(<class twisted.web.resource.IResource ...`
`int` | `isLeaf` = 0
`NoneType` | `server` = None
Inherited from Presentation
`str` | `world` = `"you didn't assign to the 'template' attribute"`

Method Details

### prePresent(self, request)

Perform any tasks which must be done before presenting the page.

  Overrides:
    `twisted.web.widgets.Presentation.prePresent` (inherited documentation)

### render(self, request)

Render a given resource. See `IResource`'s render method.

I delegate to methods of self with the form 'render_METHOD' where METHOD is the HTTP that was used to make the request. Examples: render_GET, render_HEAD, render_POST, and so on. Generally you should implement those methods instead of overriding this one.

render_METHOD methods are expected to return a string which will be the rendered page, unless the return value is twisted.web.server.NOT_DONE_YET, in which case it is this class's responsibility to write the results to request.write(data), then call request.finish().

Old code that overrides render() directly is likewise expected to return a string or NOT_DONE_YET.

  Overrides:
    `twisted.web.widgets.Page.render` (inherited documentation)

Class Variable Details

### stylesheet

  Type:
    `str`
  Value:

        '''
            a
            {
                font-family: Lucida, Verdana, Helvetica, Arial, sans-serif;
                color: #369;
                text-decoration: none;
            }

        ...

### template

  Type:
    `str`
  Value:

        '''<html>
            <head>
            <title>%%%%self.title%%%%</title>
            <style>
            %%%%self.stylesheet%%%%
            </style>
            <base href="%%%%request.prePathURL()%%%%">
            </head>
        ...

### title

  Type:
    `str`
  Value:

        'No Title'

### widget

  Type:
    `str`
  Value:

        'No Widget'

Generated by Epydoc 2.0 on Sat May 15 20:08:25 2004 | http://epydoc.sf.net